=== modified file 'ivle/webapp/urls/test_router.py'
--- ivle/webapp/urls/test_router.py	2009-07-02 03:52:29 +0000
+++ ivle/webapp/urls/test_router.py	2009-07-02 04:20:31 +0000
@@ -128,7 +128,7 @@
         assert router.resolve('/info2/2008/2') == \
                (self.r.subjects['info2'].offerings[(2008, 2)], None)
 
-    def testDefaultRoute(self):
+    def testDefaultView(self):
         router = Router(root=self.r, viewset='browser')
         router.add_set_switch('api', 'api')
         router.add_forward(Root, None, root_to_subject, 1)
@@ -157,6 +157,20 @@
         assert router.resolve('/api/info1/2009/1') == \
                (self.r.subjects['info1'].offerings[(2009, 1)], OfferingAPIIndex)
 
+    def testNoDefaultView(self):
+        router = Router(root=self.r)
+        router.add_forward(Root, None, root_to_subject, 1)
+        router.add_view(Subject, '+edit', SubjectEdit)
+
+        assert router.resolve('/info1/+edit') == \
+               (self.r.subjects['info1'], SubjectEdit)
+
+        assert router.resolve('/info1') == (self.r.subjects['info1'], None)
+
+    def testNoRoutesOrViews(self):
+        router = Router(root=self.r)
+        assert router.resolve('/blah') == (self.r, None)
+
 class TestGeneration(BaseTest):
     def testOneLevel(self):
         router = Router(root=self.r)
@@ -211,6 +225,28 @@
         else:
             raise AssertionError("did not raise RouteConflict")
 
+    def testViewConflict(self):
+        router = Router(root=self.r)
+        router.add_view(Subject, 'foo', object())
+        router.add_view(Subject, 'foo', object(), viewset='bar')
+        try:
+            router.add_view(Subject, 'foo', object())
+        except RouteConflict:
+            pass
+        else:
+            raise AssertionError("did not raise RouteConflict")
+
+    def testSetSwitchConflict(self):
+        router = Router(root=self.r)
+        router.add_set_switch('foo', 'bar')
+
+        try:
+            router.add_set_switch('foo', 'baz')
+        except RouteConflict:
+            pass
+        else:
+            raise AssertionError("did not raise RouteConflict")
+
     def testNoPath(self):
         try:
             Router(root=self.r).generate(object())

